; 

    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\Comctl32.inc
    include \masm32\include\comdlg32.inc
    include \masm32\include\shell32.inc
    include \masm32\include\oleaut32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\Comctl32.lib
    includelib \masm32\lib\comdlg32.lib
    includelib \masm32\lib\shell32.lib
    includelib \masm32\lib\oleaut32.lib

    include \masm32\macros\macros.asm
    include macros2.asm

    factnr PROTO :DWORD
    factr PROTO :DWORD
    fact_nr PROTO :DWORD
    fact_r PROTO :DWORD

; 
    .data
        recursions dd 0
        min_esp    dd 0 
    .code
; 
start:
;     
    mov   ebx, 1
    print chr$("factnr")
  @@:
    print chr$(" ")
    invoke factnr, ebx
    print ustr$(eax)
    inc   ebx
    cmp   ebx, 8
    jb    @B
    print chr$(13,10)

    mov   ebx, 1
    print chr$("factr ")
  @@:
    print chr$(" ")
    invoke factr, ebx
    print ustr$(eax)
    inc   ebx
    cmp   ebx, 8
    jb    @B
    print chr$(13,10,13,10)

    print chr$("factnr(23) clock cycles = ")
    clockctr_begin 1000000, HIGH_PRIORITY_CLASS
      invoke factnr, 23
    clockctr_end
    print ustr$(eax)
    print chr$(13,10)

    print chr$("factr(23) clock cycles = ")
    clockctr_begin 1000000, HIGH_PRIORITY_CLASS
      invoke factr, 23
    clockctr_end
    print ustr$(eax)
    print chr$(13,10,13,10)    

    mov   esi, esp
    invoke fact_nr, 23
    sub   esi, min_esp
    print chr$("fact_nr(23) stack depth = ")
    print ustr$(esi)

    mov   recursions, 0
    mov   esi, esp
    invoke fact_r, 23
    sub   esi, min_esp
    print chr$(13,10,13,10,"fact_r(23) recursions = ")
    print ustr$(recursions)
    print chr$(13,10,"fact_r(23) stack depth = ")
    print ustr$(esi)    

    mov   eax, input(13,10,13,10,"Press enter to exit...")
    exit

; 
; Non-recursive factorial, function and cycle count tests.
; 
factnr proc num:DWORD
    mov   eax, 1
    mov   ecx, 1
  @@:
    mul   ecx
    add   ecx, 1
    cmp   ecx, num
    jna   @B
    ret
factnr endp

; 
; Non-recursive factorial, other tests.
; 
fact_nr proc num:DWORD
    mov   min_esp, esp
    mov   eax, 1
    mov   ecx, 1
  @@:
    mul   ecx
    add   ecx, 1
    cmp   ecx, num
    jna   @B
    ret
fact_nr endp

; 
; Recursive factorial, function and cycle count tests.
; 
factr proc num:DWORD
    mov   eax, num
    cmp   eax, 1
    je    @F
    sub   eax, 1
    invoke fact_r, eax
    mul   num
  @@:
    ret
factr endp

; 
; Recursive factorial, other tests.
; 
fact_r proc num:DWORD
    inc   recursions
    mov   min_esp, esp
    mov   eax, num
    cmp   eax, 1
    je    @F
    sub   eax, 1
    invoke fact_r, eax
    mul   num
  @@:
    ret
fact_r endp

; 
end start
